// coding: utf-8
/*! Created by: Udo Schmal | https://www.gocher.me/ */
// sticky element
// css replacement
// #toolbar {position: sticky; position: -webkit-sticky; top: 0;}
// #nav-container {position: sticky; position: -webkit-sticky; top: 40px;}
// #nav-container.sticky {position: fixed;}
(function() {
  'use strict';
  // eventListener passive mode
  var useCapture = false;
  try {
    var opts = Object.defineProperty({}, 'passive', {
      get: function() {
        useCapture = {capture: false, passive: true};
      }
    });
    window.addEventListener("testPassive", null, opts);
    window.removeEventListener("testPassive", null, opts);
  } catch (e) {};

  function Sticky (el) {
    var supportsSticky = window.getComputedStyle(el).getPropertyValue("position") == "sticky";
    var marginTop = parseInt(window.getComputedStyle(el).getPropertyValue("top"), 10) || 0;
    function checkSticky() {
      el.style.position = 'initial';
      var rect = el.getBoundingClientRect();
      el.style.position = '';
      if (rect.y <= marginTop) {
        if (!supportsSticky) {
          el.classList.add('sticky');
        }
        el.classList.add('isSticky');
      } else {
        if (!supportsSticky) {
          el.classList.remove('sticky');
        }
        el.classList.remove('isSticky');
      }
    }
    window.addEventListener('scroll', checkSticky, useCapture);
    window.addEventListener('resize', checkSticky, useCapture);
    checkSticky();
  }
  var els = document.querySelectorAll("[data-type='sticky']");
  if (els) {
    for (var i=0; i<els.length; i++) {
      new Sticky(els[i]);
    }
  }
})();
